diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
index 598f5c9a9..29fa670d5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
@@ -9,10 +9,12 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
 
 public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHead> {
     protected IconCoordinate pistonHead;
@@ -25,8 +27,9 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
 
     protected final double headThickness;
     protected final double shaftThickness;
+
     public BlockModelPistonHead(final Block<BlockLogicPistonHead> block, final IconCoordinate pistonHead, final IconCoordinate pistonShaft) {
-        this(block, pistonHead, pistonShaft, 4/16d, 4/16d);
+        this(block, pistonHead, pistonShaft, 4 / 16d, 4 / 16d);
     }
 
     public BlockModelPistonHead(final Block<BlockLogicPistonHead> block, final IconCoordinate pistonHead, final IconCoordinate pistonShaft, final double headThickness, final double shaftThickness) {
@@ -38,58 +41,65 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        return renderPistonHead(tessellator, worldSource, block, x, y, z, true);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        return renderPistonHead(tessellator, worldSource, this.block, tilePos, true);
     }
-    public void renderPistonHeadNoCulling(Tessellator tessellator, WorldSource worldSource, Block<BlockLogicPistonHead> block, int x, int y, int z, boolean flag) {
+
+    public void renderPistonHeadNoCulling(Tessellator tessellator, WorldSource worldSource, Block<BlockLogicPistonHead> block, @NotNull TilePos tilePos, boolean flag) {
         renderBlocks.renderAllFaces = true;
-        renderPistonHead(tessellator, worldSource, block, x, y, z, flag);
+        renderPistonHead(tessellator, worldSource, block, tilePos, flag);
         renderBlocks.renderAllFaces = false;
     }
-    public void setFaceTextureOverride(@Nullable final IconCoordinate faceTexture){
+
+    public void setFaceTextureOverride(@Nullable final IconCoordinate faceTexture) {
         this.faceTextureOverride = faceTexture;
     }
-    protected boolean renderPistonHead(Tessellator tessellator, WorldSource worldSource, Block<BlockLogicPistonHead> block, int x, int y, int z, boolean flag) {
-        int metadata = worldSource.getBlockMetadata(x, y, z);
+
+    protected boolean renderPistonHead(Tessellator tessellator, WorldSource worldSource, Block<BlockLogicPistonHead> block, @NotNull TilePosc tilePos, boolean flag) {
+        int metadata = worldSource.getBlockData(tilePos);
         Direction direction = BlockLogicPistonHead.getDirectionFromMeta(metadata);
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
-        }else {
-        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, tilePos));
+        } else {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
         }
         final float f1 = flag ? 1.0F : 0.5F;
-        final double width = flag ? 1 : 1/2d;
-        switch(direction)
-        {
+        final double width = flag ? 1 : 1 / 2d;
+
+        final int x = tilePos.x();
+        final int y = tilePos.y();
+        final int z = tilePos.z();
+
+        switch (direction) {
             case DOWN: // BOTTOM
                 renderBlocks.uvRotateEast = 3;
                 renderBlocks.uvRotateWest = 3;
                 renderBlocks.uvRotateSouth = 3;
                 renderBlocks.uvRotateNorth = 3;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F), x, y, z);
-                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 + this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.6F, width);
-                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.6F, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, new AABBd(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F), tilePos);
+                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness / 2, x + 0.5 + this.shaftThickness / 2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 + this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness / 2, x + 0.5 - this.shaftThickness / 2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 - this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness / 2, x + 0.5 - this.shaftThickness / 2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 - this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, brightness * 0.6F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness / 2, x + 0.5 + this.shaftThickness / 2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 + this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, brightness * 0.6F, width);
                 break;
 
             case UP: // TOP
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
-                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 + this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.6F, width);
-                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.6F, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, new AABBd(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F), tilePos);
+                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness / 2, x + 0.5 + this.shaftThickness / 2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 + this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness / 2, x + 0.5 - this.shaftThickness / 2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 - this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness / 2, x + 0.5 - this.shaftThickness / 2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 - this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, brightness * 0.6F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness / 2, x + 0.5 + this.shaftThickness / 2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 + this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, brightness * 0.6F, width);
                 break;
 
             case NORTH: // NORTH
                 renderBlocks.uvRotateSouth = 1;
                 renderBlocks.uvRotateNorth = 2;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness), x, y, z);
-                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.5F, width);
-                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + this.headThickness, z + this.headThickness + f1, brightness, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness), tilePos);
+                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness / 2, x + 0.5 - this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness / 2, x + 0.5 + this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness / 2, x + 0.5 + this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.5F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness / 2, x + 0.5 - this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, z + this.headThickness, z + this.headThickness + f1, brightness, width);
                 break;
 
             case SOUTH: // SOUTH
@@ -97,11 +107,11 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateNorth = 1;
                 renderBlocks.uvRotateTop = 3;
                 renderBlocks.uvRotateBottom = 3;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F), x, y, z);
-                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.5F, width);
-                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, new AABBd(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F), tilePos);
+                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness / 2, x + 0.5 - this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness / 2, x + 0.5 + this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness / 2, x + 0.5 + this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.5F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness / 2, x + 0.5 - this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness, width);
                 break;
 
             case WEST: // WEST
@@ -109,11 +119,11 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateWest = 2;
                 renderBlocks.uvRotateTop = 2;
                 renderBlocks.uvRotateBottom = 1;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F), x, y, z);
-                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.5F, width);
-                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 + this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness, width);
-                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.6F, width);
-                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.6F, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, new AABBd(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F), tilePos);
+                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 - this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, brightness * 0.5F, width);
+                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 + this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, brightness, width);
+                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 - this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, brightness * 0.6F, width);
+                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 + this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, brightness * 0.6F, width);
                 break;
 
             case EAST: // EAST
@@ -121,22 +131,22 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateWest = 1;
                 renderBlocks.uvRotateTop = 1;
                 renderBlocks.uvRotateBottom = 2;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
-                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.5F, width);
-                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 + this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness, width);
-                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.6F, width);
-                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.6F, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, new AABBd(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F), tilePos);
+                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 - this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, brightness * 0.5F, width);
+                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 + this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, brightness, width);
+                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 - this.shaftThickness / 2, y + 0.5 + this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, z + 0.5 - this.shaftThickness / 2, brightness * 0.6F, width);
+                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 + this.shaftThickness / 2, y + 0.5 - this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, z + 0.5 + this.shaftThickness / 2, brightness * 0.6F, width);
                 break;
         }
         renderBlocks.resetRenderBlocks();
         return true;
     }
-    private void renderHeadTopBottom(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width)
-    {
+
+    private void renderHeadTopBottom(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width) {
         final IconCoordinate i = renderBlocks.overrideBlockTexture != null ? renderBlocks.overrideBlockTexture : this.pistonShaft;
-        final double uMin = i.getSubIconU(0.5 - this.shaftThickness/2);
+        final double uMin = i.getSubIconU(0.5 - this.shaftThickness / 2);
         final double vMin = i.getIconVMin();
-        final double uMax = i.getSubIconU(0.5 + this.shaftThickness/2);
+        final double uMax = i.getSubIconU(0.5 + this.shaftThickness / 2);
         final double vMax = i.getSubIconV(width);
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
         tessellator.addVertexWithUV(xMin, yMax, zMin, uMax, vMax);
@@ -145,12 +155,11 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
         tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMax);
     }
 
-    private void renderHeadNorthSouth(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width)
-    {
+    private void renderHeadNorthSouth(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width) {
         final IconCoordinate i = renderBlocks.overrideBlockTexture != null ? renderBlocks.overrideBlockTexture : this.pistonShaft;
-        final double uMin = i.getSubIconU(0.5 - this.shaftThickness/2);
+        final double uMin = i.getSubIconU(0.5 - this.shaftThickness / 2);
         final double vMin = i.getIconVMin();
-        final double uMax = i.getSubIconU(0.5 + this.shaftThickness/2);
+        final double uMax = i.getSubIconU(0.5 + this.shaftThickness / 2);
         final double vMax = i.getSubIconV(width);
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
         tessellator.addVertexWithUV(xMin, yMin, zMax, uMax, vMax);
@@ -159,12 +168,11 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
         tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMax);
     }
 
-    private void renderHeadEastWest(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width)
-    {
+    private void renderHeadEastWest(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width) {
         final IconCoordinate i = renderBlocks.overrideBlockTexture != null ? renderBlocks.overrideBlockTexture : this.pistonShaft;
-        final double uMin = i.getSubIconU(0.5 - this.shaftThickness/2);
+        final double uMin = i.getSubIconU(0.5 - this.shaftThickness / 2);
         final double vMin = i.getIconVMin();
-        final double uMax = i.getSubIconU(0.5 + this.shaftThickness/2);
+        final double uMax = i.getSubIconU(0.5 + this.shaftThickness / 2);
         final double vMax = i.getSubIconV(width);
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
         tessellator.addVertexWithUV(xMax, yMin, zMin, uMax, vMax);
@@ -172,18 +180,17 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
         tessellator.addVertexWithUV(xMin, yMax, zMax, uMin, vMin);
         tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMax);
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
     }
+
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         final Direction direction = BlockLogicPistonHead.getDirectionFromMeta(data);
-        if(side.getDirection() == direction)
-        {
-            if(this.faceTextureOverride != null)
-            {
+        if (side.getDirection() == direction) {
+            if (this.faceTextureOverride != null) {
                 return this.faceTextureOverride;
             }
             switch (BlockLogicPistonHead.getPistonType(data)) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java
index 0937562b6..98d876720 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPlanksPainted.java
@@ -6,13 +6,14 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPlanksPainted<T extends BlockLogic> extends BlockModelStandard<T> {
     public static final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
 
     static {
-        for (DyeColor c : DyeColor.blockOrderedColors()){
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
             texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/planks/" + c.colorID);
         }
     }
@@ -22,7 +23,7 @@ public class BlockModelPlanksPainted<T extends BlockLogic> extends BlockModelSta
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int meta) {
         return texCoords[meta & DyeColor.MASK_COLOR];
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
index 04576c568..2685af80c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
@@ -6,33 +6,34 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 public class BlockModelPortal<T extends BlockLogicPortal> extends BlockModelTransparent<T> {
     protected IconCoordinate[] colors = new IconCoordinate[16];
+
     public BlockModelPortal(Block<T> block, String rootTexKey) {
         super(block, false);
         for (DyeColor color : DyeColor.values()) {
-            colors[color.blockMeta] = TextureRegistry.getTexture(rootTexKey + color.colorID);
+            this.colors[color.blockMeta] = TextureRegistry.getTexture(rootTexKey + color.colorID);
         }
         onRenderLayer(1);
     }
+
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
-    {
-        if(blockAccess.getBlockId(x, y, z) == block.id())
-        {
+    public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @NotNull Side side) {
+        if (source.getBlockId(tilePos) == this.block.id()) {
             return false;
         }
-        return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
+        return super.shouldSideBeRendered(source, bounds, tilePos, side);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
-        return colors[block.getLogic().fromMetadata(data).blockMeta];
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        return this.colors[this.block.getLogic().fromMetadata(data).blockMeta];
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPressurePlatePainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPressurePlatePainted.java
index 7f08fa84c..d58283d25 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPressurePlatePainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPressurePlatePainted.java
@@ -6,19 +6,21 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPressurePlatePainted<T extends BlockLogic> extends BlockModelStandard<T> {
     protected final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+
     public BlockModelPressurePlatePainted(final Block<T> block) {
         super(block);
-        for (final DyeColor c : DyeColor.blockOrderedColors()){
+        for (final DyeColor c : DyeColor.blockOrderedColors()) {
             this.texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/planks/" + c.colorID);
         }
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(final Side side, final int meta) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(final @NotNull Side side, final int meta) {
         return this.texCoords[(meta >> 4) & DyeColor.MASK_COLOR];
     }
 }
